EnableExplicit

;- Window Constants
;
Enumeration
  #Window_0
EndEnumeration

;- Gadget Constants
;
Enumeration
  #String_0
  #Button_0
  #Button_1
  #Button_2
  #Text_0
  #Text_1
  #Button_3
EndEnumeration


Structure FontInfo
    name.s
    size.l
    styles.l
EndStructure

Procedure.i GetFontInfo (gadget.i,*fi.FontInfo)
    ; Ermittelt den Font eines GadGets und schreibt das 
    ; Ergebnis in die FontInfo-Struktur
    
    Protected lf.LOGFONT
    Protected hWnd.l
    Protected hFont.l
    Protected hDC.l
    
    If IsGadget(gadget)
        hWnd = GadgetID(gadget)
        hFont = GetGadgetFont(gadget)
        
        GetObject_(hFont, SizeOf(lf), @lf)
        
        *fi\name = PeekS(@lf\lfFaceName)
        
        hDC = GetDC_(hWnd)
        
        *fi\size = -MulDiv_(lf\lfHeight, 72, GetDeviceCaps_(hDC, #LOGPIXELSY))
        
        If lf\lfHeight = 700 : *fi\styles = #PB_Font_Bold   : EndIf
        If lf\lfItalic > 0 :   *fi\styles + #PB_Font_Italic : EndIf
        
        ReleaseDC_(hWnd.l, hDC)
        ProcedureReturn 1
    EndIf
    
EndProcedure

Procedure SetDialogFont(hWnd.l = #Null )
    ; Stellt in PureBasic den Standard-Dialogfont ein
    
    Protected ncm.NONCLIENTMETRICS
    Protected hDC.l
    Protected i.i
    Protected name.s, points.l, styles.l, charset.l
    
    
    ncm\cbSize = SizeOf(ncm)
    SystemParametersInfo_(#SPI_GETNONCLIENTMETRICS, SizeOf(ncm), @ncm, #Null)
    
    name = PeekS(@ncm\lfMessageFont\lfFaceName[0])
    
    charset = ncm\lfMessageFont\lfCharSet
    
    hDC = GetDC_(hWnd)
    
    points = -MulDiv_(ncm\lfMessageFont\lfHeight, 72, GetDeviceCaps_(hDC, #LOGPIXELSY))
    
    If ncm\lfMessageFont\lfWeight=700 : styles = #PB_Font_Bold : EndIf
    If ncm\lfMessageFont\lfItalic > 0 : styles = styles + #PB_Font_Italic : EndIf
    
    ReleaseDC_(hWnd.l, hDC)
    
    SetGadgetFont(#PB_Default, FontID(LoadFont(#PB_Any, name, points, styles)))
EndProcedure

Define Event.i
Define WindowID.i
Define GadgetID.i
Define EventType.i
      

Define PBFont.FontInfo
Define DlgFont.FontInfo
Define Auswahl.FontInfo

If OpenWindow(#Window_0, 216, 0, 494, 138, "Schrift-Test",  #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar )
    StringGadget(#String_0, 10, 20, 470, 30, "Das ist nur ein kleiner Text zum Testen der eingestellten Schriftart")
    ; voreingestellte PureBasic-Schriftart ermitteln
    GetFontInfo(#String_0, @PBFont)
    
    ; danach Dialog-Font as Default-Schrift einstellen
    SetDialogFont()
    ButtonGadget(#Button_0, 10, 70, 150, 30, "PureBasic")
    ButtonGadget(#Button_1, 170, 70, 150, 30, "Dialog Font")
    ButtonGadget(#Button_2, 330, 70, 150, 30, "-------")
    
    TextGadget(#Text_0, 10, 110, 150, 20, "PureBasic", #PB_Text_Center)
    TextGadget(#Text_1, 170, 110, 150, 20, "Dialog Font", #PB_Text_Center)
    ButtonGadget(#Button_3, 330, 110, 150, 20, "Font auswhlen")
    
    ; DialogFont 
    GetFontInfo(#Button_0,@DlgFont)
    
    SetGadgetText(#Button_0, PBFont\name + " / " + Str(PBFont\size))
    SetGadgetText(#Button_1, DlgFont\name + " / " + Str(DlgFont\size))
    
    Repeat ; Start of the event loop
      
      Event = WaitWindowEvent() ; This line waits until an event is received from Windows
      WindowID = EventWindow() ; The Window where the event is generated, can be used in the gadget procedures
      GadgetID = EventGadget() ; Is it a gadget event?
      EventType = EventType() ; The event type
      
      If Event = #PB_Event_Gadget
        
        If GadgetID = #String_0
          
        ElseIf GadgetID = #Button_0     ; PB-Standard einstellen
            SetGadgetFont(#String_0, FontID(LoadFont(#PB_Any, PBFont\name, PBFont\size, PBFont\styles)))  
            
        ElseIf GadgetID = #Button_1     ; Dialogfont einstellen
            SetGadgetFont(#String_0, FontID(LoadFont(#PB_Any, DlgFont\name, DlgFont\size, DlgFont\styles)))  
            
        ElseIf GadgetID = #Button_2     ; einen selber Ausgewhlten Font einstellen
            If Auswahl\name > ""
                SetGadgetFont(#String_0, FontID(LoadFont(#PB_Any, Auswahl\name, Auswahl\size, Auswahl\styles)))  
            EndIf
            
        ElseIf GadgetID = #Button_3     ; einen Font auswhlen. Als Vorgabe wird der eingestellte Font genommen
            GetFontInfo(#String_0, Auswahl)
            If FontRequester(Auswahl\name,Auswahl\size,0,0,Auswahl\styles)
                Auswahl\name = SelectedFontName()
                Auswahl\size = SelectedFontSize()
                Auswahl\styles = SelectedFontStyle()
                SetGadgetFont(#String_0, FontID(LoadFont(#PB_Any, Auswahl\name, Auswahl\size, Auswahl\styles)))  
                SetGadgetText(#Button_2, Auswahl\name + " / " + Str(Auswahl\size))    
            EndIf
        EndIf
      EndIf
      
    Until Event = #PB_Event_CloseWindow ; End of the event loop
    EndIf

End
;

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 138
; Folding = 9
; EnableXP